import { AnyType, InferType, NullableType, OptionalType } from '../types';
/**
 * Creates the type definition that allows both `undefined` and `null` values.
 *
 * @param type The underlying type definition.
 * @param defaultValue The value that should be used if input is `undefined`.
 */
export declare function nullish<X extends AnyType>(type: X, defaultValue?: InferType<X> | null): OptionalType<NullableType<X>>;
