import { ConstraintOptions, Dict, Primitive, Several } from '../shared-types';
import { OneOfType } from '../types';
/**
 * The type definition that constrains input with the list of primitive values.
 *
 * @param values The list of values allowed for the input.
 * @param options
 */
export declare function oneOf<T extends Primitive, U extends Several<T>>(values: U, options?: ConstraintOptions): OneOfType<U[number]>;
/**
 * The type definition that constrains input with values of the enum-like object.
 *
 * @param values The enum-like object.
 * @param options
 */
export declare function oneOf<U extends Dict<string | number>>(values: U, options?: ConstraintOptions): OneOfType<U[keyof U]>;
