import { __extends } from "tslib";
import { Type } from './Type';
import { raiseIssue } from '../utils';
/**
 * The boolean type definition.
 */
var BooleanType = /** @class */ (function (_super) {
    __extends(BooleanType, _super);
    function BooleanType(options) {
        return _super.call(this, false, options) || this;
    }
    BooleanType.prototype.parse = function (input, options) {
        if (typeof input !== 'boolean') {
            raiseIssue(input, 'type', 'boolean', this.options, 'Must be a boolean');
        }
        return input;
    };
    return BooleanType;
}(Type));
export { BooleanType };
