import { Type } from './Type';
import { ConstraintOptions, ParserOptions } from '../shared-types';
/**
 * The type of the arbitrary constructor.
 */
export declare type Constructor<T> = new (...args: any[]) => T;
export declare type InferConstructorType<C> = C extends Constructor<infer T> ? T : never;
/**
 * The class instance type definition.
 *
 * @template C The class instance constructor.
 */
export declare class InstanceOfType<C extends Constructor<any>> extends Type<InferConstructorType<C>> {
    protected ctor: C;
    constructor(ctor: C, options?: ConstraintOptions);
    parse(input: unknown, options?: ParserOptions): InferConstructorType<C>;
}
