import { __extends } from "tslib";
import { Type } from './Type';
import { raiseIssue } from '../utils';
/**
 * The class instance type definition.
 *
 * @template C The class instance constructor.
 */
var InstanceOfType = /** @class */ (function (_super) {
    __extends(InstanceOfType, _super);
    function InstanceOfType(ctor, options) {
        var _this = _super.call(this, false, options) || this;
        _this.ctor = ctor;
        return _this;
    }
    InstanceOfType.prototype.parse = function (input, options) {
        var ctor = this.ctor;
        if (!(input instanceof ctor)) {
            raiseIssue(input, 'instanceOf', ctor, this.options, 'Must be an instance of ' + ctor.name);
        }
        return input;
    };
    return InstanceOfType;
}(Type));
export { InstanceOfType };
