import { __extends } from "tslib";
import { NumberType } from './NumberType';
import { raiseIssue } from '../utils';
var isInteger = Number.isInteger;
/**
 * The integer type definition.
 */
var IntegerType = /** @class */ (function (_super) {
    __extends(IntegerType, _super);
    function IntegerType(options) {
        return _super.call(this, options) || this;
    }
    IntegerType.prototype.parse = function (input, options) {
        if (!isInteger(input)) {
            raiseIssue(input, 'type', 'integer', this.options, 'Must be an integer');
        }
        return _super.prototype.parse.call(this, input, options);
    };
    return IntegerType;
}(NumberType));
export { IntegerType };
