import { AnyType, InferType, Type } from './Type';
import { Awaitable, ParserOptions } from '../shared-types';
/**
 * The lazily-evaluated type definition.
 *
 * @template X The type definition returned by the provider.
 */
export declare class LazyType<X extends AnyType> extends Type<InferType<X>> {
    private provider;
    protected type: X | undefined;
    /**
     * Creates a new {@link LazyType} instance.
     *
     * @param provider Returns the type definition that must be applied to the input value.
     */
    constructor(async: boolean, provider: () => X);
    parse(input: unknown, options?: ParserOptions): Awaitable<InferType<X>>;
}
