import { __extends } from "tslib";
import { Type } from './Type';
/**
 * The lazily-evaluated type definition.
 *
 * @template X The type definition returned by the provider.
 */
var LazyType = /** @class */ (function (_super) {
    __extends(LazyType, _super);
    /**
     * Creates a new {@link LazyType} instance.
     *
     * @param provider Returns the type definition that must be applied to the input value.
     */
    function LazyType(async, provider) {
        var _this = _super.call(this, async) || this;
        _this.provider = provider;
        return _this;
    }
    LazyType.prototype.parse = function (input, options) {
        return (this.type || (this.type = this.provider())).parse(input, options);
    };
    return LazyType;
}(Type));
export { LazyType };
