import { Awaitable, ConstraintOptions, ParserOptions, Primitive } from '../shared-types';
import { Type } from './Type';
/**
 * The literal value type definition.
 *
 * @template T The literal value.
 */
export declare class LiteralType<T extends Primitive> extends Type<T> {
    protected value: T;
    /**
     * Creates a new {@link LiteralType} instance.
     *
     * @param value The literal value that is compared with the input value.
     * @param options
     */
    constructor(value: T, options?: ConstraintOptions);
    parse(input: any, options?: ParserOptions): Awaitable<T>;
}
