import { __extends } from "tslib";
import { Type } from './Type';
import { isEqual, raiseIssue } from '../utils';
/**
 * The literal value type definition.
 *
 * @template T The literal value.
 */
var LiteralType = /** @class */ (function (_super) {
    __extends(LiteralType, _super);
    /**
     * Creates a new {@link LiteralType} instance.
     *
     * @param value The literal value that is compared with the input value.
     * @param options
     */
    function LiteralType(value, options) {
        var _this = _super.call(this, false, options) || this;
        _this.value = value;
        return _this;
    }
    LiteralType.prototype.parse = function (input, options) {
        var value = this.value;
        if (!isEqual(input, value)) {
            raiseIssue(input, 'literal', value, this.options, 'Must be exactly equal to ' + value);
        }
        return input;
    };
    return LiteralType;
}(Type));
export { LiteralType };
