import { AnyType, InferType, Type } from './Type';
import { Awaitable, ParserOptions } from '../shared-types';
/**
 * The nullable type definition.
 *
 * @template X The underlying type definition.
 */
export declare class NullableType<X extends AnyType> extends Type<InferType<X> | null> {
    protected type: X;
    /**
     * Creates a new {@link NullableType} instance.
     *
     * @param type The underlying type definition.
     */
    constructor(type: X);
    parse(input: unknown, options?: ParserOptions): Awaitable<InferType<X> | null>;
}
