import { __extends } from "tslib";
import { Type } from './Type';
/**
 * The nullable type definition.
 *
 * @template X The underlying type definition.
 */
var NullableType = /** @class */ (function (_super) {
    __extends(NullableType, _super);
    /**
     * Creates a new {@link NullableType} instance.
     *
     * @param type The underlying type definition.
     */
    function NullableType(type) {
        var _this = _super.call(this, type.async) || this;
        _this.type = type;
        return _this;
    }
    NullableType.prototype.parse = function (input, options) {
        var type = this.type;
        if (input === null) {
            return type.async ? Promise.resolve(input) : input;
        }
        return type.parse(input, options);
    };
    return NullableType;
}(Type));
export { NullableType };
