import { ConstraintOptions, ParserOptions, Primitive } from '../shared-types';
import { Type } from './Type';
/**
 * The type definition that constrains input to one of the primitive values.
 *
 * @template T The type of the allowed values.
 */
export declare class OneOfType<T extends Primitive> extends Type<T> {
    protected values: T[];
    /**
     * Creates a new {@link OneOfType} instance.
     *
     * @param values The list of values allowed for the input.
     * @param options
     */
    constructor(values: T[], options?: ConstraintOptions);
    parse(input: any, options?: ParserOptions): T;
}
