import { __extends } from "tslib";
import { Type } from './Type';
/**
 * The optional type definition.
 *
 * @template X The underlying type definition.
 */
var OptionalType = /** @class */ (function (_super) {
    __extends(OptionalType, _super);
    /**
     * Creates a new {@link OptionalType} instance.
     *
     * @param type The underlying type definition.
     * @param defaultValue The value that should be used if input is `undefined`.
     */
    function OptionalType(type, defaultValue) {
        var _this = _super.call(this, type.async) || this;
        _this.type = type;
        _this.defaultValue = defaultValue;
        return _this;
    }
    OptionalType.prototype.parse = function (input, options) {
        var _a = this, type = _a.type, defaultValue = _a.defaultValue;
        if (input === undefined) {
            return type.async ? Promise.resolve(defaultValue) : defaultValue;
        }
        return type.parse(input, options);
    };
    return OptionalType;
}(Type));
export { OptionalType };
