import { AnyType, InferType, Type } from './Type';
import { Awaitable, ConstraintOptions, ParserOptions } from '../shared-types';
export declare class RecordType<K extends Type<string>, V extends AnyType> extends Type<Record<InferType<K>, InferType<V>>> {
    protected keyType: K;
    protected valueType: V;
    constructor(keyType: K, valueType: V, options?: ConstraintOptions);
    parse(input: unknown, options?: ParserOptions): Awaitable<Record<InferType<K>, InferType<V>>>;
}
