import { AnyType, InferType, Type } from './Type';
import { Awaitable, ParserOptions, Several } from '../shared-types';
export declare type InferUnionType<U extends Several<AnyType>> = {
    [K in keyof U]: InferType<U[K]>;
}[number];
/**
 * The union type definition.
 *
 * @template U The list of united type definitions.
 */
export declare class UnionType<U extends Several<AnyType>> extends Type<InferUnionType<U>> {
    protected types: U;
    /**
     * Creates a new {@link UnionType} instance.
     *
     * @param types The list of united type definitions.
     */
    constructor(types: U);
    parse(input: unknown, options?: ParserOptions): Awaitable<InferUnionType<U>>;
}
