import { ConstraintOptions, Dict, Issue, ParserOptions } from './shared-types';
import { AnyType } from '../main';
export declare function raiseIssue(input: unknown, code: string, param: unknown, options: ConstraintOptions | undefined, message: string): never;
export declare function raiseIssuesOrPush(issues: Issue[] | undefined, parserOptions: ParserOptions | undefined, input: unknown, code: string, param: unknown, options: ConstraintOptions | undefined, message: string): Issue[];
export declare function raiseIssuesIfDefined(issues: Issue[]): never;
export declare function raiseIssuesIfDefined(issues: Issue[] | undefined): void;
export declare function raiseIssuesOrCaptureForKey(error: unknown, issues: Issue[] | undefined, parserOptions: ParserOptions | undefined, key: unknown): Issue[];
export declare function cloneObject<T extends object>(value: T): T;
export declare function isObjectLike(value: unknown): value is Dict;
export declare function createCatchForKey(key: unknown): (error: unknown) => never;
export declare function createValuesExtractor(issues?: Issue[]): <T>(results: PromiseSettledResult<T>[]) => T[];
export declare function isFast(options: ParserOptions | undefined): boolean;
export declare function isAsync(types: Array<AnyType>): boolean;
export declare const isEqual: (value1: any, value2: any) => boolean;
export declare const isArray: (arg: any) => arg is any[];
export declare const promiseAll: {
    <T>(values: Iterable<T | PromiseLike<T>>): Promise<Awaited<T>[]>;
    <T_1 extends readonly unknown[] | []>(values: T_1): Promise<{ -readonly [P in keyof T_1]: Awaited<T_1[P]>; }>;
};
export declare const promiseAllSettled: {
    <T extends readonly unknown[] | []>(values: T): Promise<{ -readonly [P in keyof T]: PromiseSettledResult<Awaited<T[P]>>; }>;
    <T_1>(values: Iterable<T_1 | PromiseLike<T_1>>): Promise<PromiseSettledResult<Awaited<T_1>>[]>;
};
export declare function parseAsync(type: AnyType, input: any, options: ParserOptions | undefined): Promise<any>;
export declare function isEqualArray(a: any[], b: any[]): boolean;
export declare function returnNull(): null;
export declare function extractIssues(error: unknown): Issue[];
export declare function copyObjectKnownKeys(input: Dict, keys: string[]): Dict;
export declare function copyObjectEnumerableKeys(input: Dict, keyCount?: number): Dict;
export declare function returnTrue(): boolean;
export declare function returnFalse(): boolean;
